Const DebugMode = FALSE
Const DeleteTempFiles = True
Const ForReading = 1
Const ForAppending = 8
const HKEY_LOCAL_MACHINE = &H80000002


Set wshShell = WScript.CreateObject( "WScript.Shell" )


strcomputername = wshShell.ExpandEnvironmentStrings( "%COMPUTERNAME%" )


on error resume next


    machine = wshShell.ExpandEnvironmentStrings( "%COMPUTERNAME%" )
    
    set osvcRemote = GetObject("winmgmts:\\" & machine & "\root\cimv2")

    ' Error reporting for machines that are not available or firewalled
    IF Err.Number <> 0 THEN
        html = html + "<span class=""critical"">Unable to connect to '" & machine & "'</span><br/><br/>"
        csv = csv & machine & ",Unavailable" & VBNewLine
        Err.Clear
    Else

        'Find out if its 32bit or 64bit - Added March 2017 - MB
        strProcKey = "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"
        strProc = "PROCESSOR_ARCHITECTURE"

        Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & machine & "\root\default:StdRegProv")
        oReg.GetStringValue HKEY_LOCAL_MACHINE,strProcKey,strProc,Proc
        
        If Proc = "x86" Then
            str3264 = ""
        Else
            str3264 = "WOW6432Node\"
        End If

        If DebugMode = FALSE Then 
        Else
            wscript.echo machine & " detected as " & Proc & VBNewLine & "Processor Architecture detected as " & Proc
        End If
        'End 32bit or 64bit checks

        ' DAT VERSION - Registry keys in HKEY_LOCAL_MACHINE for McAfee DAT Version
        strKeyPath8700 = "SOFTWARE\" & str3264 & "Network Associates\ePolicy Orchestrator\Application Plugins\VIRUSCAN8700"
        strKeyPath8800 = "SOFTWARE\" & str3264 & "Network Associates\ePolicy Orchestrator\Application Plugins\VIRUSCAN8800"
        strKeyPathTreatPrevention = "SOFTWARE\McAfee\AVSolution\DatReputation\"
        strKeyPathENS10 = "SOFTWARE\McAfee\AVSolution\DS\DS"
        strKeyPathAMCore = "SOFTWARE\McAfee\AVSolution\AVS\AVS\"
		strKeyPathEngine = "SOFTWARE\McAfee\Endpoint\AV\AVCM\"
		
        If DebugMode = FALSE Then 
        Else
            wscript.echo "Possible Values:" & VBNewLine & VBNewLine & strKeyPath8700 & VBNewLine & strKeyPath8800 & VBNewLine & strKeyPathTreatPrevention & VBNewLine & strKeyPathENS10 & strKeyPathAMCore & strKeyPathEngine
        End If
        
        ' Set to not found and then update when DAT version retrieved
        strValueNotFound = TRUE  ' DAT Version
        astrValueNotFound = TRUE ' DAT Date
        
        ' Check for McAfee Endpoint Security (ENS)
        'Set oReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & machine & "\root\default:StdRegProv")
        oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPathENS10, "dwContentMajorVersion", intValue
        If Not IsNull(intValue) Then
            strValueNotFound = FALSE
            strValueName = "dwContentMajorVersion"
            strValue = "" & intValue
            oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPathENS10, "dwContentMinorVersion", intValue
            If Not IsNull(intValue) Then
                strValue = strValue & "." & intValue
            End If
			
		' Check for McAfee Endpoint Security (ENS) Engine
		oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPathEngine, "EMajor", intValue
		If Not IsNull(intValue) Then
            strEngineValueNotFound = FALSE
            strEngineValueName = "Engine"
            strEngineValue = "" & intValue
            oReg.GetDWORDValue HKEY_LOCAL_MACHINE, strKeyPathEngine, "EMinor", intValue
            If Not IsNull(intValue) Then
                strEngineValue = strEngineValue & "." & intValue
            End If
            
		' Check for McAfee Endpoint Security (ENS) AMCORE VERSION
		oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPathAMCore, "szAMCoreVersion",strAMCoreValue
		If Not IsNull Then
            strAMCoreValueNotFound = FALSE
            strAMCoreValueName = "AMCore"
          
            End If
            
            'Get DAT Date
            astrValueName = "szContentCreationDate" ' Retrieved in format yyyy-mm-dd
            oReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPathENS10, astrValueName, astrValue
            If Not IsNull(astrValue) Then
                astrValueNotFound = FALSE
                
                'Need to change for format yyyy/mm/dd
                astrValue = Replace(astrValue, "-", "/")
            End If
        End If			

        Else
            ' Check for McAfee Endpoint Security (ENS) - Older version
            oReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPathTreatPrevention,"szRepDATVer",strValue
            If Not IsNull(strValue) Then
                strValueNotFound = FALSE
                strValueName  = "szRepDATVer"
                astrValue = "NA" ' Don't know where to find the DAT date for this version of McAfee ENS
            Else


   
           
             ' Check for McAfee VSE 8.8
                strValueName = "DATVersion"
                oReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath8800,strValueName,strValue

                If Not IsNull(strValue) Then
                    strValueNotFound = FALSE
				oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath8800, "EngineVersion", VSEEngValue
				If Not IsNull(VSEEngValue) Then
				strEngineValueNotFound = FALSE
				strEngineValueName = "Engine"
				strEngineValue = "" & VSEEngValue
				If Not IsNull(VSEEngValue) Then
                strEngineValue = strEngineValue
				End If
				oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath8800, "Software ID",strAMCoreValue
				If Not IsNull Then
				strAMCoreValueNotFound = FALSE
				strAMCoreValueName = "AMCore"
End if
End if
               ' Check for DAT Date
                astrKeyPath = "SOFTWARE\" & str3264 & "McAfee\AVEngine"
                astrValueName  = "AVDatDate"
                oReg.GetStringValue HKEY_LOCAL_MACHINE, astrKeyPath, astrValueName, astrValue
                If Not IsNull(astrValue) Then
                    astrValueNotFound = FALSE
                End If
          Else
				
                ' Check for McAfee VSE 8.7
                strValueName = "DATVersion"
				oReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath8700,strValueName,strValue

                    If Not IsNull(strValue) Then
                        strValueNotFound = FALSE
				oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath8700, "Version", VSEEngValue
				If Not IsNull(VSEEngValue) Then
				strEngineValueNotFound = FALSE
				strEngineValueName = "Engine"
				strEngineValue = "" & VSEEngValue
				If Not IsNull(VSEEngValue) Then
                strEngineValue = strEngineValue
				End If
				oReg.GetStringValue HKEY_LOCAL_MACHINE, strKeyPath8700, "Software ID",strAMCoreValue
				If Not IsNull Then
				strAMCoreValueNotFound = FALSE
				strAMCoreValueName = "AMCore"
				                Else
				            End If	
				            End If	
							End If	
									
 
	
                    
  
                
                ' Check for DAT Date
                astrKeyPath = "SOFTWARE\" & str3264 & "McAfee\AVEngine"
                astrValueName  = "AVDatDate"
                oReg.GetStringValue HKEY_LOCAL_MACHINE, astrKeyPath, astrValueName, astrValue
                If Not IsNull(astrValue) Then
                    astrValueNotFound = FALSE
                End If
				

            	End If
		
	
            End If
            
        End If ' Move this later when completed code
        
        If DebugMode = FALSE Then 
        Else
            wscript.echo strValueName & ": " & strValue
			wscript.echo strEngineValueName & ": " & strEngineValue
			wscript.echo strAMCoreValueName & ": " & strAMCoreValue
        End If

        ' Added check for if no value found enter NA - added by Matt Bailey Aug 2012
        If strValueNotFound = TRUE Then
            strValue = "NA"
        End if
        
        If astrValueNotFound = TRUE Then
            astrValue = "NA"
        End if
        ' End error checking for no DAT Version

        ' Error Checking for no AV date added by Matt Bailey Aug 2012
        If astrValueNotFound = TRUE Then
            If DebugMode = FALSE Then 
            Else
                wscript.echo "DAT Date not found: " & astrValueName & ": " & astrValue
            End If
        Else
            If DebugMode = FALSE Then 
            Else
                wscript.echo "DAT Date found: " & astrValueName & ": " & astrValue
			End If	
			defdate= (DateDiff("d",astrValue,Date))
			
			IF	defdate <= 2 Then
			wscript.echo "0 McAfee defage=" & defdate & "|DAT=" & strValue & "|Engine=" & strEngineValue & "|AMCore=" & strAMCoreValue & " McAfee OK;Updated:" & astrValue & ";DAT:" & strValue & ";Engine:" & strEngineValue & ";AMCore:" & strAMCoreValue
			Else
			IF	defdate =< 5 Then
			wscript.echo "1 McAfee defage=" & defdate & "|DAT=" & strValue & "|Engine=" & strEngineValue & "|AMCore=" & strAMCoreValue & " McAfee Not Updated Recently;Updated:" & astrValue & ";DAT:" & strValue & ";Engine:" & strEngineValue & ";AMCore:" & strAMCoreValue
			Else
			
			IF	defdate => 8 Then
			wscript.echo "2 McAfee defage=" & defdate & "|DAT=" & strValue & "|Engine=" & strEngineValue & "|AMCore=" & strAMCoreValue & " McAfee Out Of Date;Updated:" & astrValue & ";DAT:" & strValue & ";Engine:" & strEngineValue & ";AMCore:" & strAMCoreValue
						Else		
			
			IF	astrValue = NA Then
			wscript.echo "2 McAfee defage=" & defdate & "|DAT=" & strValue & "|Engine=" & strEngineValue & "|AMCore=" & strAMCoreValue & " McAfee Issue With DAT;Updated:" & astrValue & ";DAT:" & strValue & ";Engine:" & strEngineValue & ";AMCore:" & strAMCoreValue
			Else
			End If
			End If
            End If
			End If
			
        End If

        If strValueNotFound And astrValueNotFound Then
		wscript.echo "2 McAfee defage=" & defdate & "|DAT=" & strValue & "|Engine=" & strEngineValue & "|AMCore=" & strAMCoreValue & " McAfee Issue With DAT;Updated:" & astrValue & ";DAT:" & strValue & ";Engine:" & strEngineValue & ";AMCore:" & strAMCoreValue
        End if
        ' End error checking for no AV date
End if
' End script
wscript.Quit